const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const social_links = sequelize.define(
    'social_links',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      network: {
        type: DataTypes.ENUM,

        values: [
          'TWITTER',

          'INSTAGRAM',

          'YOUTUBE',

          'TIKTOK',

          'FACEBOOK',

          'LINKEDIN',

          'GITHUB',

          'CUSTOM',
        ],
      },

      handle: {
        type: DataTypes.TEXT,
      },

      url: {
        type: DataTypes.TEXT,
      },

      order_index: {
        type: DataTypes.INTEGER,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  social_links.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.social_links.belongsTo(db.blocks, {
      as: 'block',
      foreignKey: {
        name: 'blockId',
      },
      constraints: false,
    });

    db.social_links.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.social_links.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.social_links.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return social_links;
};
